datablock AudioProfile(BombWhistleSound)
{
	filename    = "./bombWhistleLoop.wav";
	description = AudioDefaultLooping3d;
	preload = true;
};
if(!isObject(rocketLoopSound))
{
	datablock AudioProfile(rocketExplodeSound)
	{
		filename    = "Add-Ons/weapon_rocket_launcher/tntExplode.wav";
		description = AudioDefault3d;
		preload = true;
	};
}
datablock ParticleData(ArtilleryShellExplosionParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = 0.5;
   inheritedVelFactor   = 0;
   constantAcceleration = 0.0;
   lifetimeMS           = 1200;
   lifetimeVarianceMS   = 130;
   textureName          = "base/data/particles/cloud";
   spinSpeed			= 35.0;
   spinRandomMin		= -50.0;
   spinRandomMax		= 50.0;
   colors[0]     = "0.9 0.3 0.0 0.95";
   colors[1]     = "0.8 0.6 0.0 0.7";
   colors[2]     = "0.5 0.0 0.0 0.0";
   sizes[0]      = 5.0;
   sizes[1]      = 24.0;
   sizes[2]      = 18.0;
   times[0] = 0.0;
   times[1] = 0.3;
   times[2] = 1.0;

   useInvAlpha = true;
};
datablock ParticleEmitterData(ArtilleryShellExplosionEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 50;
   velocityVariance = 2.5;
   ejectionOffset   = 3.0;
   thetaMin         = 135;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ArtilleryShellExplosionParticle";
};

datablock ParticleData(ArtilleryShellExplosionParticle2)
{
   dragCoefficient      = 8;
   gravityCoefficient   = -2;
   inheritedVelFactor   = 0;
   constantAcceleration = 0.0;
   lifetimeMS           = 700;
   lifetimeVarianceMS   = 400;
   textureName          = "base/data/particles/cloud";
   spinSpeed			= 15.0;
   spinRandomMin		= -30.0;
   spinRandomMax		= 30.0;
   colors[0]     = "0.4 0.4 0.4 1";
   colors[1]     = "0.0 0.0 0.0 0.8";
   colors[2]     = "0.0 0.0 0.0 0.0";
   sizes[0]      = 10.0;
   sizes[1]      = 14.0;
   sizes[2]      = 1.0;
   times[0] = 0.0;
   times[1] = 0.1;
   times[2] = 1.0;

   useInvAlpha = true;
};
datablock ParticleEmitterData(ArtilleryShellExplosionEmitter2)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 110;
   velocityVariance = 2.5;
   ejectionOffset   = 3.0;
   thetaMin         = 85;
   thetaMax         = 95;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ArtilleryShellExplosionParticle2";
};

datablock ParticleData(ArtilleryShellExplosionRingParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 60;
   lifetimeVarianceMS   = 20;
   textureName          = "base/data/particles/star1";
   spinSpeed		= 5.0;
   spinRandomMin		= -200.0;
   spinRandomMax		= 200.0;
   colors[0]     = "1 0.8 0.0 0.7";
   colors[1]     = "0.9 0.2 0.0 0.2";
   sizes[0]      = 8;
   sizes[1]      = 18;

   useInvAlpha = false;
};
datablock ParticleEmitterData(ArtilleryShellExplosionRingEmitter)
{
   lifeTimeMS = 30;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ArtilleryShellExplosionRingParticle";
};


datablock ParticleData(ArtilleryShellExplosionChunkParticle)
{
   dragCoefficient      = 0;
   gravityCoefficient   = 6;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1400;
   lifetimeVarianceMS   = 1300;
   textureName          = "base/data/particles/chunk";
   spinSpeed		= 10.0;
   spinRandomMin		= -500.0;
   spinRandomMax		= 500.0;
   colors[0]     = "0.1 0.1 0.1 0.5";
   colors[1]     = "0.0 0.0 0.0 0.4";
   sizes[0]      = 0.9;
   sizes[1]      = 0;

   useInvAlpha = true;
};
datablock ParticleEmitterData(ArtilleryShellExplosionChunkEmitter)
{
   lifeTimeMS = 25;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 35;
   velocityVariance = 0.0;
   ejectionOffset   = 3.0;
   thetaMin         = 120;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ArtilleryShellExplosionChunkParticle";
};


datablock ExplosionData(ArtilleryShellExplosion)
{
   explosionShape = "add-ons/weapon_rocket_launcher/explosionSphere1.dts";
   soundProfile = rocketExplodeSound;

   lifeTimeMS = 300;

   particleEmitter = ArtilleryShellExplosionEmitter;
   particleDensity = 11;
   particleRadius = 1.5;

   emitter[0] = ArtilleryShellExplosionRingEmitter;
   emitter[1] = ArtilleryShellExplosionChunkEmitter;
   emitter[2] = ArtilleryShellExplosionEmitter2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 13.0 10.0";
   camShakeAmp = "4.0 15.0 4.0";
   camShakeDuration = 0.5;
   camShakeRadius = 35.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 0.7 0 1";
   lightEndColor = "1 0 0 0";

   damageRadius = 14;
   radiusDamage = 150;

   impulseRadius = 8;
   impulseForce = 4000;

   playerBurnTime = 5000;
};

/////////////////
//  Projectile //
/////////////////

datablock ParticleData(ArtilleryTrailParticle)
{
   dragCoefficient      = 2.5;
   gravityCoefficient   = 0.1;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1500;
   lifetimeVarianceMS   = 150;
   textureName          = "base/data/particles/dot";
   colors[0]     = "1.0 1.0 1.0 0.9";
   colors[1]     = "0.2 0.2 0.2 0.3";
   sizes[0]      = 1;
   sizes[1]      = 0.15;
   times[0] 	 = 0;
   times[1] 	 = 1;

   useInvAlpha = false;
};
datablock ParticleEmitterData(ArtilleryTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ArtilleryTrailParticle";
};

datablock ProjectileData(ArtilleryShellProjectile)
{
   projectileShapeName = "add-ons/vehicle_tank/tankBullet.dts";
   directDamage        = 200;
   directDamageType = $DamageType::RocketDirect;
   radiusDamageType = $DamageType::RocketRadius;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = ArtilleryShellExplosion;
   particleEmitter     = ArtilleryTrailEmitter;
   
   sound				= BombWhistleSound;

   brickExplosionRadius = 12;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 95;             
   brickExplosionMaxVolume = 55;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 70;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   muzzleVelocity      = 65;
   velInheritFactor    = 1.0;

   armingDelay         = 0;
   lifetime            = 12000;
   fadeDelay           = 11500;
   isBallistic         = true;
   gravityMod = 1.0;

   uiName = "Artillery Shell";
};